#include <stdio.h>
#include <math.h>
#include <ctype.h>

#define INT		int
#define UBYTE 		unsigned char
#define BYTE  		char
#define UWORD 		unsigned short int
#define WORD  		short int
#define ULONG 		unsigned long int
#define LONG  		long int
#define DOUBLE 		double
#define FLOAT		float
#define VOID 		void
#define BOOL 		int

#ifndef _true_
#define TRUE 1
#define _true_
#endif

#ifndef _false_
#define FALSE 0
#define _false_
#endif

#define streq(a,b)	(strcmp(a,b)==0)

#define SEEK_SET   	0
#define MAX_STATIONS	80
#define MAX_CHANNELS	30	
#define MAX_POLES       40
#define MAX_ZEROS       40
#define MAX_CALIB       9 
#define MAX_INPUT_FILES 6
#define MAXLINE         200
#define MAX_NAME        90
#define LREC_SIZE       4096 

#define VAR11	11
#define VAR21	21
#define VAR23	23
#define VAR27	27
#define VAR31	31	
#define VAR51	51
#define VAR61	61
#define VAR71	71

BOOL	Upcase;

BOOL	BLACKNEST;
BOOL	GRAEFENBERG;
BOOL	NARS;
BOOL	GDSN;
BOOL    ODC;
BOOL    POSEIDON;
BOOL 	ECHERY;
BOOL    NORESS;
BOOL    DWWSSN;
BOOL    RSTN;
BOOL    ASRO, SRO;
BOOL    GEOSCOPE;
BOOL    WARNING1;
BOOL    WARNING2;
BOOL    FIRST_INPUT_FILE;
BOOL    EXTRACT;
INT     SDAY;

BOOL    BROAD_BAND;
BOOL    MID_PERIOD;
BOOL    LONG_PERIOD;
BOOL    VERY_LONG_PERIOD;
BOOL    ULTRA_LONG_PERIOD;
	
#define COMPLEX struct _complex
COMPLEX {
	double x;
	double y;
};

#define STDTIME struct _time 
STDTIME {
	 INT 	msec;
	 INT	second;
	 INT	minute;
	 INT	hour;
	 INT	day;
	 INT	year;
};

#define STDTIME2 struct _time2 
STDTIME2 {
	 float	second;
	 INT	minute;
	 INT	hour;
	 INT	day;
	 INT	year;
};

#define TRANSFER struct _transfer
TRANSFER {
	double	A0;
	double	norm_freq;
        int     numpoles;
	COMPLEX	poles[MAX_POLES];
	COMPLEX zeros[MAX_ZEROS];
        int     numzeros;
	COMPLEX	poles_error[MAX_POLES];
	COMPLEX zeros_error[MAX_ZEROS];
        int     numcals;
        double  sens;
        double  calib[MAX_CALIB];
        double  cal_freq[MAX_CALIB];
        STDTIME cal_time[MAX_CALIB];
};


extern char *x_malloc();
char *x_calloc();
void x_free();
void x_chkfree();



