
#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include <gdd.h>
#include <search.h>
#include "OLsunic1_ui.h"
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <string.h>
#include <math.h>
#include <malloc.h>


#ifndef _true_
#define TRUE 1
#define _true_
#endif

#ifndef _false_
#define FALSE 0
#define _false_
#endif

#define MAX_TRIGGERS 15
/*  #define MAX_STATIONS  60  */
/*  #define MAX_CHANNELS  10 */
#define MAX_EVENTS  10
#define MAX_DATA_TYPES 3
#define DATA int

int NUMBER_CHANNELS_KNOWN;
int SPDATA;
int LPDATA;
int IPDATA;
int SHORTP_CHOSEN;
int LONGP_CHOSEN;
int INTERMP_CHOSEN;
int HBB_CHOSEN, BB_CHOSEN, MP_CHOSEN, LP_CHOSEN, VLP_CHOSEN, ULP_CHOSEN;
int BP_FILTER, HP_FILTER;
int PASS1;
char selected_evline[80];


#define path_elements    struct _pe
/* #define STDTIME          struct _stdtime */
#define TRIGGER_STRUCT   struct _trigger_str
#define DATA_TYPE_STRUCT struct _data_type_str
#define STATION_STRUCT   struct _station_ent
#define evinfo           struct _ev_info



path_elements {
        char dev_name[190];
        char year[10]; 
        char  month[10]; 
        char file[140];
};


/*
STDTIME {
	int             year;
	int             day;
	int             hour;
	int             minute;
	int             second;
	int             msec;
};
*/

evinfo {
	STDTIME         time;
        int             month;
        int             day_of_month;
        float           lat;
        float           lon;
        float           dep;
        float           mb;
        float           ms;
};

TRIGGER_STRUCT {
	STDTIME         start_time;
        STDTIME         end_time;
        int             first_block_no;
        int             total_blocks;
        int             first_sample_no;
        int             last_sample_no;
	int             R1;
        int             npoints;
	int             dN;
        int             bool;
	double		t1;
};


DATA_TYPE_STRUCT {
	float            dt;
        TRIGGER_STRUCT   *trigger[MAX_TRIGGERS];
        int              Ntriggers;
};


STATION_STRUCT {
        float           epi;
	int              station_log;
        char             station_code[6];
        int              datablocks[4];
        int              formatID;
        int              number_channels[4];
        DATA_TYPE_STRUCT *data_entry[4];
        DATA_TYPE_STRUCT *seed_entry[10][4];  /* SEED, dtype, channel      */
        int              stationID;
        char             inst[6];
        char            lat[12];
        char            lon[12];
        char            elev[12];
        float           flat;
        float           flon;
        float           felev;
        float           back;
        float           time_cor;     /*  time correction (GDSN)  */
	int             cdorder;
	int		selected;
	int             hbb, bb, mp, lp, vlp, ulp;

};


#define Winfor struct winfo_
Winfor {
 	int    x,y;
        unsigned int width, height;
};
