/******************************************************************************/
/****                                                                       ***/
/****       Written by:       Reinoud Sleeman                               ***/
/****                                                                       ***/
/****                                                                       ***/
/****       Orfeus Data Center                                              ***/
/****                                                                       ***/
/****       Budapestlaan 4                                                  ***/
/****       3584 CD  Utrecht                                                ***/
/****       The Netherlands                                                 ***/
/****                                                                       ***/
/****                                                                       ***/
/****       21/02/92           Version 1.9            CDLOOK                ***/
/****                                                                       ***/
/******************************************************************************/

#define MANTISSA_MASK 0x0fff			/* mask for mantissa */
#define GAINRANGE_MASK 0x7000			/* mask for gainrange factor */
#define SHIFT 12				/* # bits in mantissa */
#define MAX12 0x7ff				/* maximum 12 bit positive # */

extern float *ydata[];
extern int   *xdata[];

extern float  ech_gf[];

void decode_echery (data_ptr, nsamples, index, pt)
char *data_ptr;
int nsamples;
int index, pt;
{
	short int *ptr, word;
	int mantissa;				/* mantissa from SEED data */
	int gainrange;				/* gain range factor */
	int exponent;				/* total exponent */
	double sample;				/* sample value */
	int i;					/* counter */



	ptr = (short int *) data_ptr;

	for (i = 0; i < nsamples; i++)
	{
		/* recover mantissa and gain range factor */
		word = (short int) (*(ptr+i));
		mantissa = ((int) word & MANTISSA_MASK);
                mantissa -= 2048;
		gainrange = ((int) word & GAINRANGE_MASK) >> SHIFT;


		/* calculate sample from mantissa and exponent */
		sample = (double) mantissa * ech_gf[gainrange];

		/* save sample in seismic data array */

                *(ydata[pt]+index+i) = (float)(sample);
                *(xdata[pt]+index+i) = index+i;


	}
}
