/******************************************************************************/
/****                                                                       ***/
/****       Written by:       Reinoud Sleeman                               ***/
/****                                                                       ***/
/****                                                                       ***/
/****       Orfeus Data Center                                              ***/
/****                                                                       ***/
/****       Budapestlaan 4                                                  ***/
/****       3584 CD  Utrecht                                                ***/
/****       The Netherlands                                                 ***/
/****                                                                       ***/
/****                                                                       ***/
/****       21/02/92           Version 1.9            CDLOOK                ***/
/****                                                                       ***/
/******************************************************************************/
#define MANTISSA_MASK 0xfff0		/* mask for mantissa */
#define GAINRANGE_MASK 0x000f		/* mask for gainrange factor */
#define SHIFT  4			/* # bits in mantissa */

float grf[15] = {1024, 512, 256, 128, 64, 32, 16, 8, 4, 2, 1,
			0.5, 0.25, 0.125, 0.0625};

extern  float  *ydata[];
extern  int    *xdata[];

void decode_graef (data_ptr, nsamp, index, pt)
char *data_ptr;
int nsamp, index, pt;
{
	int mantissa;				/* mantissa from SEED data */
	int gainrange;				/* gain range factor */
	int i;					/* counter */
        short int word, *ptr;


        ptr = ( short int *) data_ptr;

	for (i = 0; i < nsamp; i++ ) {

		word = (short int)  (*(ptr+i));
		mantissa = ((int) word & MANTISSA_MASK) >> SHIFT;
		gainrange = ((int) word & GAINRANGE_MASK);

		if ( mantissa >= 2048 ) mantissa -= 4096;

		*(ydata[pt]+index+i) = (float) (mantissa *grf[gainrange]);
                *(xdata[pt]+index+i) =  index + i;

	}
}
