/******************************************************************************/
/****                                                                       ***/
/****       Written by:       Reinoud Sleeman                               ***/
/****                                                                       ***/
/****                                                                       ***/
/****       Orfeus Data Center                                              ***/
/****                                                                       ***/
/****       Budapestlaan 4                                                  ***/
/****       3584 CD  Utrecht                                                ***/
/****       The Netherlands                                                 ***/
/****                                                                       ***/
/****                                                                       ***/
/****       21/02/92           Version 1.9            CDLOOK                ***/
/****                                                                       ***/
/******************************************************************************/
float    rstn_gainf[]  = { 1, 4, 16, 128 };

#define MANTISSA_MASK 0x3fff			/* mask for mantissa */
#define GAINRANGE_MASK 0xd000			/* mask for gainrange factor */
#define SHIFT 14				/* # bits in mantissa */

extern float *ydata[];
extern int   *xdata[];

void decode_rstn (data_ptr, nsamp, index, pt)
char *data_ptr;
int nsamp, index, pt;
{
	int mantissa;				/* mantissa from SEED data */
	int gainrange;				/* gain range factor */
	int i;					/* counter */
        short int word, *ptr;

	ptr = (short int *) data_ptr;

	for (i = 0; i < nsamp ; i++ )
	{
		word = (short int ) (*(ptr+i));
		mantissa = ((int) word & MANTISSA_MASK);
		gainrange = ((int) word & GAINRANGE_MASK) >> SHIFT;

                mantissa -= 8191;


                *(ydata[pt]+index+i) = (float)(mantissa * rstn_gainf[gainrange]);
                *(xdata[pt]+index+i) = index+i;
	}
}
