/******************************************************************************/
/****                                                                       ***/
/****       Written by:       Reinoud Sleeman                               ***/
/****                                                                       ***/
/****                                                                       ***/
/****       Orfeus Data Center                                              ***/
/****                                                                       ***/
/****       Budapestlaan 4                                                  ***/
/****       3584 CD  Utrecht                                                ***/
/****       The Netherlands                                                 ***/
/****                                                                       ***/
/****                                                                       ***/
/****       21/02/92           Version 1.9            CDLOOK                ***/
/****                                                                       ***/
/******************************************************************************/
float    sro_gainf[]  = { 1024, 512, 256, 128, 64, 32, 16, 8, 4, 2, 1, 
                       .5, .25, .125, .0625, .03125 };

#define MANTISSA_MASK 0x0fff			/* mask for mantissa */
#define GAINRANGE_MASK 0xf000			/* mask for gainrange factor */
#define SHIFT 12				/* # bits in mantissa */

extern float *ydata[];
extern int   *xdata[];

void decode_sro (data_ptr, nsamp, index, pt)
char *data_ptr;
int nsamp, index, pt;
{
	int mantissa;				/* mantissa from SEED data */
	int gainrange;				/* gain range factor */
	int i;					/* counter */
        short int word, *ptr;

	ptr = (short int *) data_ptr;

	for (i = 0; i < nsamp ; i++ )
	{
		word = (short int ) (*(ptr+i));
		mantissa = ((int) word & MANTISSA_MASK);
		gainrange = ((int) word & GAINRANGE_MASK) >> SHIFT;

                if(mantissa>=2048) mantissa -= 4096;


                *(ydata[pt]+index+i) = (float)(mantissa * sro_gainf[gainrange]);
                *(xdata[pt]+index+i) = index+i;
	}
}
