/******************************************************************************/
/****                                                                       ***/
/****       Written by:       Reinoud Sleeman                               ***/
/****                                                                       ***/
/****                                                                       ***/
/****       Orfeus Data Center                                              ***/
/****                                                                       ***/
/****       Budapestlaan 4                                                  ***/
/****       3584 CD  Utrecht                                                ***/
/****       The Netherlands                                                 ***/
/****                                                                       ***/
/****                                                                       ***/
/****       21/02/92           Version 1.9            CDLOOK                ***/
/****                                                                       ***/
/******************************************************************************/
#include "user.h"


STATION_STRUCT *init_stinfo()
{
	STATION_STRUCT *stinfo;
	int i,j;

	stinfo = (STATION_STRUCT *) malloc ( sizeof(STATION_STRUCT) );
        if(stinfo==NULL) return(NULL);

        stinfo->epi = 0;
        stinfo->station_log = 0;
        stinfo->formatID = 0;
        for(i=0;i<4;i++) {
              stinfo->datablocks[i] = 0;
              stinfo->number_channels[i] = 0;
              stinfo->data_entry[i] = NULL;
        }
        for(i=0;i<10;i++) {
              for(j=0;j<4;j++)
                  stinfo->seed_entry[i][j] = NULL;
        }
        stinfo->time_cor = 0;
	stinfo->hbb = FALSE;
	stinfo->bb = FALSE;
	stinfo->mp = FALSE;
	stinfo->lp = FALSE;
	stinfo->vlp = FALSE;
	stinfo->ulp = FALSE;

	return ( stinfo );
}


DATA_TYPE_STRUCT *InitDataTypeStruct()
{
	DATA_TYPE_STRUCT *data_entry;
        int i;

	data_entry = (DATA_TYPE_STRUCT *) malloc( sizeof(DATA_TYPE_STRUCT));
        if(data_entry==NULL) return(NULL);
        data_entry->dt = 0;
        for ( i=0; i< MAX_TRIGGERS; i++ ) 
              data_entry->trigger[i] = NULL;
        data_entry->Ntriggers = 0;

	return ( data_entry );

}


TRIGGER_STRUCT *InitTriggerStruct()
{
	TRIGGER_STRUCT *trig;

	trig = (TRIGGER_STRUCT *) malloc ( sizeof(TRIGGER_STRUCT) );
        trig->start_time.year = 0;
        trig->start_time.day = 0;
        trig->start_time.hour = 0;
        trig->start_time.minute = 0;
        trig->start_time.second = 0;
        trig->start_time.msec = 0;
        trig->end_time.year = 0;
        trig->end_time.day = 0;
        trig->end_time.hour = 0;
        trig->end_time.minute = 0;
        trig->end_time.second = 0;
        trig->end_time.msec = 0;
        trig->first_block_no = 0;
        trig->total_blocks = 0;
        trig->first_sample_no = 0;
        trig->last_sample_no = 0;
	trig->R1 = 0;
	trig->npoints = 0;
	trig->dN = 0;

	return ( trig );
}

