#include "conver.h"
#include "user2.h"
#include "seed.h"

void print_type53 (fp,sty, chy,zp)
FILE *fp;
ZEROS_POLES *zp;
STATION_ENTRY *sty;
CHANNEL_ENTRY *chy;
{
	int i;		

	fprintf (fp,"+                  +--------------------");
	fprintf (fp,"----------------------+               +\n");
	fprintf (fp,"+                  |   Instrument response, %5s ch %3s (%02d)",
		sty->Call_Letters, chy->Identifier, chy->SubChannel);
	fprintf (fp," |               +\n");
	fprintf (fp,"+                  +--------------------");
	fprintf (fp,"----------------------+               +\n");
	fprintf (fp,"\n");

	fprintf (fp,"Response type:                         Poles and zeroes\n");



		switch (zp->Function_Type) {

			case 'A' : fprintf (fp,"Transfer function type:                 Laplace Transform (Rad/sec)\n"); break;
			case 'B' : fprintf (fp,"Transfer function type:                 Analog (Hz)\n"); break;
			case 'C' : fprintf (fp,"Transfer function type:                 Composite\n"); break;
			case 'D' : fprintf (fp,"Transfer function type:                 Digital (Z-transform)\n"); break;
			default  : fprintf (fp,"Transfer function type:                %s\n", zp->Function_Type); break;
		}

		fprintf (fp,"Stage sequence number:                 %d\n",
			zp->Cascade);
		fprintf (fp,"Response in units lookup:              %s\n",
			zp->Response_In->Comment);
		fprintf (fp,"Response out units lookup:             %s\n",
			zp->Response_Out->Comment);
		fprintf (fp,"AO normalization factor:               %G\n",
			zp->A0_Normalization);
		fprintf (fp,"Normalization frequency:               %G\n",
			zp->Norm_Frequency);
		fprintf (fp,"Number of zeroes:                      %d\n",
			zp->Complex_Zeros);
		fprintf (fp,"Number of poles:                       %d\n",
			zp->Complex_Poles);
		fprintf (fp,"Complex zeroes:\n");
		fprintf (fp,"  i  real          imag          real_error    imag_error\n");
		for (i = 0; i < zp->Complex_Zeros; i++)
			fprintf (fp,"%3d % E % E % E % E\n", i, 
			*(zp->Zero_Real_List+i), 
			*(zp->Zero_Imag_List+i),
			*(zp->Zero_Real_Errors+i), 
			*(zp->Zero_Imag_Errors+i));
		fprintf (fp,"Complex poles:\n");
		fprintf (fp,"  i  real          imag          real_error    imag_error\n");
		for (i = 0; i < zp->Complex_Poles; i++)
			fprintf (fp,"%3d % E % E % E % E\n", i, 
			*(zp->Pole_Real_List+i), 
			*(zp->Pole_Imag_List+i),
			*(zp->Pole_Real_Errors+i), 
			*(zp->Pole_Imag_Errors+i));
		fprintf (fp,"\n");
}
