#include "conver.h"
#include "user2.h"
#include "seed.h"

void print_type58 (fp,sty, chy,sens)
FILE *fp;
SENSITIVITY *sens;
STATION_ENTRY *sty;
CHANNEL_ENTRY *chy;
{
	int i;		

	fprintf (fp,"+                  +--------------------");
	fprintf (fp,"-------------------+                  +\n");
	fprintf (fp,"+                  |   Channel sensitivity, %5s ch %3s",
		sty->Call_Letters, chy->Identifier);
	fprintf (fp,"   |                  +\n");
	fprintf (fp,"+                  +--------------------");
	fprintf (fp,"-------------------+                  +\n");
	fprintf (fp,"\n");

	        fprintf (fp,"Stage sequence number:                 %d\n",
			sens->Cascade);
		fprintf (fp,"Sensitivity:                           %E\n",
			sens->Sensitivity);
		fprintf (fp,"Frequency of sensitivity:              %E HZ\n",
			sens->Frequency);
		fprintf (fp,"Number of calibrations:                %d\n",
			sens->Num_Cals);

		if (sens->Num_Cals != 0) {

			fprintf (fp,"Calibrations:\n");
			fprintf (fp," i, sensitivity, frequency, time of calibration\n");
			for (i = 0; i < sens->Num_Cals; i++)
				fprintf (fp,"%3d % E % E %03d,%02:%02d:%02d.%03d\n", i, 
				sens->Cal_Value[i], 
				sens->Cal_Freq[i],
                                sens->Cal_Time[i].day,
                                sens->Cal_Time[i].hour,
                                sens->Cal_Time[i].minute,
                                sens->Cal_Time[i].second,
                                sens->Cal_Time[i].msec);
		}
		fprintf (fp,"\n");
}
