/******************************************************************************/
/****                                                                       ***/
/****       Written by:       Reinoud Sleeman                               ***/
/****                                                                       ***/
/****                                                                       ***/
/****       Orfeus Data Center                                              ***/
/****                                                                       ***/
/****       Budapestlaan 4                                                  ***/
/****       3584 CD  Utrecht                                                ***/
/****       The Netherlands                                                 ***/
/****                                                                       ***/
/****                                                                       ***/
/****       21/02/92           Version 1.9            CDLOOK                ***/
/****                                                                       ***/
/******************************************************************************/
#include <stdio.h>
#include "user.h"
#include "icon_bitmap1"
#include <X11/cursorfont.h>
#include <xview/font.h>


extern XID                xid;
extern GC                 gc, revgc;
extern Display            *display; 
extern Xv_Window          canvas_pw;
extern int                cursor_shape;
extern Cursor             cursor;
extern Pixmap             px;

extern OLsunic1_base_window_objects    *bfr;


int            screen;
unsigned long  bg, fg;
Xv_Font        font, font_ori;
XFontStruct    *xfont;


welcome_screen ( )
{
	XWindowAttributes win_at;
	char              welcome[300];
        int               len, width;

	screen = DefaultScreen(display);
	bg = WhitePixel(display,screen);
	fg = BlackPixel(display,screen);



        if((xfont = XLoadQueryFont(display,"8x13bold"))) 
                XSetFont ( display, gc, (Font) xfont->fid);
        else if((xfont = XLoadQueryFont(display,"fixed"))) 
                XSetFont ( display, gc, (Font) xfont->fid);

        XGetWindowAttributes(display,xid,&win_at);
	XClearWindow ( display, xid );


        strcpy ( welcome, "WELCOME to CDLOOK ");
        len = strlen(welcome);
        width = XTextWidth ( xfont, welcome, len );
        XDrawString ( display, xid, gc, (win_at.width - width)/2, 100, welcome, len );

        strcpy ( welcome, "A way of monitoring digital earthquake data on CD-ROM.");
        len = strlen(welcome);
        width = XTextWidth ( xfont, welcome, len );
        XDrawString ( display, xid, gc, (win_at.width - width)/2, 140, welcome, len );

        strcpy ( welcome, "CDLOOK runs in the Open Windows environment.");
        len = strlen(welcome);
        width = XTextWidth ( xfont, welcome, len );
        XDrawString ( display, xid, gc, (win_at.width - width)/2, 180, welcome, len );

        strcpy ( welcome, "CDLOOK is designed for event oriented data in GDSN and SEED format.");
        len = strlen(welcome);
        width = XTextWidth ( xfont, welcome, len );
        XDrawString ( display, xid, gc, (win_at.width - width)/2, 220, welcome, len );


        strcpy ( welcome, "Messages in the lower LEFT corner will tell you what to do.");
        len = strlen(welcome);
        width = XTextWidth ( xfont, welcome, len );
        XDrawString ( display, xid, gc, (win_at.width - width)/2, 400, welcome, len );

        
        strcpy ( welcome, "Status messages will be shown in the lower RIGHT corner.");
        len = strlen(welcome);
        width = XTextWidth ( xfont, welcome, len );
        XDrawString ( display, xid, gc, (win_at.width - width)/2, 440, welcome, len );

        /* Original font */
        if((xfont = XLoadQueryFont(display,"fixed"))) 
                XSetFont ( display, gc, (Font) xfont->fid);

        printf("\n\n\tSTART SELECTION -\n\n");

}


continue_screen ( )
{
	XWindowAttributes win_at;
	char              welcome[300];
        int               len, width;

	screen = DefaultScreen(display);
	bg = WhitePixel(display,screen);
	fg = BlackPixel(display,screen);



        if((xfont = XLoadQueryFont(display,"8x13bold"))) 
                XSetFont ( display, gc, (Font) xfont->fid);
        else if((xfont = XLoadQueryFont(display,"fixed"))) 
                XSetFont ( display, gc, (Font) xfont->fid);

        XGetWindowAttributes(display,xid,&win_at);
	XClearWindow ( display, xid );


        strcpy ( welcome, "No data for this event / station / datatype / channel combination. ");
        len = strlen(welcome);
        width = XTextWidth ( xfont, welcome, len );
        XDrawString ( display, xid, gc, (win_at.width - width)/2, 100, welcome, len );

        strcpy ( welcome, "Continue with selection.");
        len = strlen(welcome);
        width = XTextWidth ( xfont, welcome, len );
        XDrawString ( display, xid, gc, (win_at.width - width)/2, 140, welcome, len );

        /* Original font */
        if((xfont = XLoadQueryFont(display,"fixed"))) 
                XSetFont ( display, gc, (Font) xfont->fid);

}


no_event_screen ( )
{
	XWindowAttributes win_at;
	char              welcome[300];
        int               len, width;

	screen = DefaultScreen(display);
	bg = WhitePixel(display,screen);
	fg = BlackPixel(display,screen);



        if((xfont = XLoadQueryFont(display,"8x13bold"))) 
                XSetFont ( display, gc, (Font) xfont->fid);
        else if((xfont = XLoadQueryFont(display,"fixed"))) 
                XSetFont ( display, gc, (Font) xfont->fid);

        XGetWindowAttributes(display,xid,&win_at);
	XClearWindow ( display, xid );


        strcpy ( welcome, "I can't find event information for this day !");
        len = strlen(welcome);
        width = XTextWidth ( xfont, welcome, len );
        XDrawString ( display, xid, gc, (win_at.width - width)/2, 100, welcome, len );

        strcpy ( welcome, "Continue with selection.");
        len = strlen(welcome);
        width = XTextWidth ( xfont, welcome, len );
        XDrawString ( display, xid, gc, (win_at.width - width)/2, 140, welcome, len );

        /* Original font */
        if((xfont = XLoadQueryFont(display,"fixed"))) 
                XSetFont ( display, gc, (Font) xfont->fid);

}
