/****************************************************************************/
/**                                                                        **/
/**    Module: MENU - Functions to print the menu (text mode).             **/
/**                                                                        **/
/****************************************************************************/
  
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <conio.h>
#include "menu.h"
#include "sonic.h"
  
extern int DisplayDevice;        /*  Defined in module dispdriv  */

char *mmenu[8] = {
    " DATA TYPE  ",
    " STATION    ",
    " PLOT TYPE  ",
    " EVENT      ",
    " DAY        ",
    " MONTH/YEAR ",
    " QUIT       ",
""};
  
char *pmenu[3] = {
    " AMPLITUDE vs. TIME PLOT            ",
    " EPICENTRAL DISTANCE  vs. TIME PLOT ",
""};
  
char *mnu1[2] = {
    " MENU SELECTION ",
""};
  
char *mnu2[2] = {
    "   USE ARROW KEYS TO SELECT THEN PRESS ENTER  (ESC TO QUIT)                   ",
""};
  
char *mnu3[2] = {
    "   USE ARROW KEYS TO SELECT THEN PRESS ENTER  (ESC RETURNS TO PREVIOUS MENU)  ",
""};
  
char *menu1[2] = {
    "                                                                                 ",
"" };
  
int plchoice;
union REGS regs;
  
void prmmenu ( row )
int *row;
{
    int inpt, col;
  
    clearscr ();
    screen_setup();

    textdisp (mnu1, 0, 1, 18, 1);
    textdisp (mmenu, 4, 5, 15, 11);
    textdisp (mnu2, 0, 23, strlen(mnu2[0]), 23);

    col = 0;
    *row = 5;
    inpt = menucurs6 (row, &col, 3,4,16,12,
    3,4,16,12,
    3,4,16,12,
    3,4,16,12,
    3,4,16,12,
    3,4,16,12);
  
    if ( inpt == ESC ) {
        *row = 11;
        return;
    }
    if ( *row != 11 )  clearscr ();
}
  
int prpmenu ( evinfo )
char *evinfo;
{
    int col, row, inpt;
  
    clearscr ();
    screen_setup();
    
    blankstring (menu1[0]);
    strcpy (menu1[0], " SELECT PLOT TYPE");
    textdisp (menu1, 0, 1, 79, 1);
  
    blankstring (menu1[0]);
    strcpy (menu1[0], "   DATE        TIME        LAT       LON    DEPTH   MB   MS ");
    textdisp (menu1, 2, 5, 79, 5);

    blankstring (menu1[0]);
    strcpy (menu1[0], evinfo);
    textdisp (menu1, 2, 6, 79, 6);
    textdisp (pmenu, 1, 8, strlen(pmenu[0]), 9);
  
    textdisp (mnu3, 0, 23, strlen(mnu3[0])-1, 23);
  
    col = 0;
    row = 8;
    inpt = menucurs6 (&row, &col, 0,7,37,10,
    0,7,37,10,
    0,7,37,10,
    0,7,37,10,
    0,7,37,10,
    0,7,37,10);
  
    if ( inpt == ESC ) return ESC;
    plchoice = ( row == 8 ) ? 1 : 2 ;
    return (1);
}
  
void textdisp ( txt_buf, ulx, uly, lrx, lry )
char *txt_buf[];
int ulx, uly, lrx, lry;
{
    char scr_assy[DISPLAY_WIDTH];
    int element, posn, col;
    unsigned int row_len;
    unsigned int srcseg, srcoff, destseg, destoff;
    struct SREGS segregs;
  
    row_len = ( (lrx-ulx) + 1 ) * 2;
 
    segread(&segregs);
  
    srcseg = segregs.ds;
    srcoff = (unsigned int)scr_assy;
    destseg = 0xb800;
    destoff = (ulx * 2) + (uly * DISPLAY_WIDTH);
  
    for ( element = 0; element <= (lry-uly);
    ++element, destoff += DISPLAY_WIDTH ) {
        movedata (destseg, destoff, srcseg, srcoff, row_len);
        for ( posn = 0, col=0; col <= (lrx - ulx); posn += 2, ++col)
            scr_assy[posn] = txt_buf[element][col];
        movedata (srcseg, srcoff, destseg, destoff, row_len);
    }
}
  
int menucurs6 ( row, col, ulx1, uly1, lrx1, lry1, ulx2, uly2, lrx2, lry2,
ulx3, uly3, lrx3, lry3, ulx4, uly4, lrx4, lry4,
ulx5, uly5, lrx5, lry5, ulx6, uly6, lrx6, lry6 )
  
int *row, *col, ulx1, uly1, lrx1, lry1, ulx2, uly2, lrx2, lry2;
int ulx3, uly3, lrx3, lry3, ulx4, uly4, lrx4, lry4 ;
int ulx5, uly5, lrx5, lry5, ulx6, uly6, lrx6, lry6 ;
{
    int inchar, ulx, uly, lrx, lry;
  
    if ( *col == 0 ) {
        ulx = ulx1;
        uly = uly1;
        lrx = lrx1;
        lry = lry1;
    }
    else if ( *col == 1 ) {
        ulx = ulx2;
        uly = uly2;
        lrx = lrx2;
        lry = lry2;
    }
    else if ( *col == 2 ) {
        ulx = ulx3;
        uly = uly3;
        lrx = lrx3;
        lry = lry3;
    }
    else  if ( *col == 3 ) {
        ulx = ulx4;
        uly = uly4;
        lrx = lrx4;
        lry = lry4;
    }
    else  if ( *col == 4 ) {
        ulx = ulx5;
        uly = uly5;
        lrx = lrx5;
        lry = lry5;
    }
    else if ( *col == 5 ) {
        ulx = ulx6;
        uly = uly5;
        lrx = lrx6;
        lry = lry6;
    }
  
    re_vid (*row, ulx, uly, lrx, lry);
  
    do {
  
        inchar = retkey();
  
        switch (inchar)
        {
            case ESC:
                return ESC;
            case UP:
                if ( (*row == (uly2+1) && *col == 1) ||
                    (*row == (uly3+1) && *col == 2) ||
                    (*row == (uly4+1) && *col == 3) ||
                    (*row == (uly5+1) && *col == 4) ||
                    (*row == (uly6+1) && *col == 5) )
                { --*col;
                    re_vid (*row, ulx, uly, lrx, lry);
                    if ( *col == 0 ) {
                        *row = *row + (lry1-uly1-2);
                        ulx = ulx1;
                        lrx = lrx1;
                    }
                    else if ( *col == 1 ) {
                        *row = *row + (lry2-uly2-2);
                        ulx = ulx2;
                        lrx = lrx2;
                    }
                    else if ( *col == 2 ) {
                        *row = *row + (lry3-uly3-2);
                        ulx = ulx3;
                        lrx = lrx3;
                    }
                    else if ( *col == 3 ) {
                        *row = *row + (lry4-uly4-2);
                        ulx = ulx4;
                        lrx = lrx4;
                    }
                    else if ( *col == 4 ) {
                        *row = *row + (lry5-uly5-2);
                        ulx = ulx5;
                        lrx = lrx5;
                    }
                    re_vid (*row, ulx, uly, lrx, lry);
                    break;
                }
  
                if ( *row == (uly+1) )
                    break;
                re_vid (*row, ulx, uly, lrx, lry);
                set_curs (--*row, ulx+1);
                re_vid (*row, ulx, uly, lrx, lry);
                break;
            case DOWN:
                if ( ( *row == (lry1-1) && *col == 0 && ulx1 != ulx2 ) ||
                    ( *row == (lry2-1) && *col == 1 && ulx2 != ulx3 ) ||
                    ( *row == (lry3-1) && *col == 2 && ulx3 != ulx4 ) ||
                    ( *row == (lry4-1) && *col == 3 && ulx4 != ulx5 ) ||
                    ( *row == (lry5-1) && *col == 4 && ulx5 != ulx6 ) )
                { ++*col;
                    re_vid (*row, ulx, uly, lrx, lry);
                    if ( *col == 1 ) {
                        *row = *row - (lry1-uly1-2);
                        ulx = ulx2;
                        lrx = lrx2;
                    }
                    else if ( *col == 2 ) {
                        *row = *row - (lry2-uly2-2);
                        ulx = ulx3;
                        lrx = lrx3;
                    }
                    else if ( *col == 3 ) {
                        *row = *row - (lry3-uly3-2);
                        ulx = ulx4;
                        lrx = lrx4;
                    }
                    else if ( *col == 4 ) {
                        *row = *row - (lry4-uly4-2);
                        ulx = ulx5;
                        lrx = lrx5;
                    }
                    else if ( *col == 5 ) {
                        *row = *row - (lry5-uly5-2);
                        ulx = ulx6;
                        lrx = lrx6;
                    }
                    re_vid (*row, ulx, uly, lrx, lry);
                    break;
                }
  
                if ( (*row == (lry1-1) && *col == 0) ||
                    (*row == (lry2-1) && *col == 1) ||
                    (*row == (lry3-1) && *col == 2) ||
                    (*row == (lry4-1) && *col == 3) ||
                    (*row == (lry5-1) && *col == 4) ||
                    (*row == (lry6-1) && *col == 5) )
                    break;
  
                re_vid (*row, ulx, uly, lrx, lry);
                set_curs (++*row, ulx+1);
                re_vid (*row, ulx, uly, lrx, lry);
                break;
  
  
            case RIGHT:
                if (  *col == 5 ||
                    (*col == 0 && ulx1 == ulx2) ||
                    (*col == 0 && (*row < (uly2-1) || *row > (lry2-1)) ) ||
                    (*col == 1 && ulx2 == ulx3) ||
                    (*col == 1 && (*row < (uly3-1) || *row > (lry3-1)) ) ||
                    (*col == 2 && ulx3 == ulx4) ||
                    (*col == 2 && (*row < (uly4-1) || *row > (lry4-1)) ) ||
                    (*col == 3 && ulx4 == ulx5) ||
                    (*col == 3 && (*row < (uly5-1) || *row > (lry5-1)) ) ||
                    (*col == 4 && ulx5 == ulx6) ||
                    (*col == 4 && (*row < (uly6-1) || *row > (lry6-1)) )
                    )
                    break;
                else
                { ++*col;
                    re_vid (*row, ulx, uly, lrx, lry);
                    if (*col == 1) {
                        ulx = ulx2;
                        lrx = lrx2;
                    }
                    else if (*col == 2) {
                        ulx = ulx3;
                        lrx = lrx3;
                    }
                    else if (*col == 3) {
                        ulx = ulx4;
                        lrx = lrx4;
                    }
                    else if (*col == 4) {
                        ulx = ulx5;
                        lrx = lrx5;
                    }
                    else if (*col == 5) {
                        ulx = ulx6;
                        lrx = lrx6;
                    }
                    set_curs (*row, ulx+1);
                    re_vid (*row, ulx, uly, lrx, lry);
                    break;
                }
            case LEFT:
                if (  *col == 0 ||
                    (*col == 1 && (*row < (uly1-1) || *row > (lry1-1)) ) ||
                    (*col == 2 && (*row < (uly2-1) || *row > (lry2-1)) ) ||
                    (*col == 3 && (*row < (uly3-1) || *row > (lry3-1)) ) ||
                    (*col == 4 && (*row < (uly4-1) || *row > (lry4-1)) ) ||
                    (*col == 5 && (*row < (uly5-1) || *row > (lry5-1)) )
                    )
                    break;
                else
                { --*col;
                    re_vid (*row, ulx, uly, lrx, lry);
                    if (*col == 0) {
                        ulx = ulx1;
                        lrx = lrx1;
                    }
                    else if (*col == 1) {
                        ulx = ulx2;
                        lrx = lrx2;
                    }
                    else if (*col == 2) {
                        ulx = ulx3;
                        lrx = lrx3;
                    }
                    else if (*col == 3) {
                        ulx = ulx4;
                        lrx = lrx4;
                    }
                    else if (*col == 4) {
                        ulx = ulx5;
                        lrx = lrx5;
                    }
                    set_curs (*row, ulx+1);
                    re_vid (*row, ulx, uly, lrx, lry);
                    break;
                }
        }
    }
    while ((inchar != ENTER) && (inchar != ESC));
  
    re_vid (*row, ulx, uly, lrx, lry);
    return (*row);
}
  
void re_vid ( row, ulx, uly, lrx, lry )
int row, ulx, uly, lrx, lry;
{
    unsigned char ch;
    int inchar;
    int foregr, backgr;
  
    for (inchar = ulx+1; inchar <= lrx-1; ++inchar) {
        set_curs (row,inchar);
        ch= rd_attri(&foregr, &backgr);
        set_attr (ch, backgr, foregr, 1);
    }
}
  
void set_curs ( row, col )
int row, col;
{
  
    regs.h.ah = 2;
    regs.h.bh = 0;
    regs.h.dh = row;
    regs.h.dl = col;
    int86 (0x10, &regs, &regs);
}
  
unsigned char rd_attri ( foregr, backgr )
int *foregr, *backgr;
{
    regs.h.bh = 0;
    regs.h.ah= 0x08;
    int86 (0x10, &regs, &regs);
    *foregr = regs.h.ah & 0xF;
    *backgr = regs.h.ah >> 4;
    return(regs.h.al);
}
  
void set_attr ( ch, foregr, backgr, count )
unsigned char ch;
int foregr, backgr, count;
{
    regs.h.ah = 0x09;
    regs.h.bh = 0;
    regs.x.cx = count;
    regs.h.al = ch;
    regs.h.bl = foregr | backgr << 4;
    int86 (0x10, &regs, &regs);
}
  
int retkey()
{
    int inchar;
  
    if (!inkey(&inchar)) inchar += 0x100;
    while (kbhit()) getch();
    return (inchar);
}
  
int inkey ( ascii )
int *ascii;
{
    regs.x.ax = 0;
    int86 (22, &regs, &regs);
    *ascii = regs.h.ah;
    if (regs.h.al == 0) return (0);
    *ascii = regs.h.al;
    return (1);
}
  
void screen_setup()
{
   set_colour ( 1, 0, 1, 79, 3);
   set_colour ( 2, 0, 4, 79,21);
   set_colour ( 1, 0,22, 79,24);
}

void set_colour ( type, ulx, uly, lrx, lry )
int type, ulx, uly, lrx, lry;
{
    int color;
    
   if ( DisplayDevice == 0 ) color = WHITE << 4 | BLACK ;
   else {     
        switch ( type ) {
            case 1:
                color = CYAN << 4 | BLUE ;
                break;
  
            case 2:
                color = BLUE << 4 | WHITE ;
                break;

            case 3:
                color = RED << 4 | WHITE ;
                break;

            default:
                color = BLUE << 4 | WHITE ;
                break;
        }
   }
   menucol ( ulx, uly, lrx, lry, color );
}
  
void menucol ( ulx, uly, lrx, lry, color )
  
int ulx, uly, lrx, lry, color;
{
    char far *offset;
    char far *base = (char far *) 0xB8000000L;   /*  declaration for menucol()  */
    int x, y;
  
    for ( x=ulx; x <= lrx; ++x) {
        for ( y=uly; y <= lry; ++y) {
            offset = base +  ( ( (long)x << 1 ) + WIDTH * (long)y );
            *++offset = color;
        }
    }
}
  
void clearscr ()
{
    regs.h.ah = 7;
    regs.h.al = 0;
    regs.h.ch = 0;
    regs.h.cl = 0;
    regs.h.dh = 24;
    regs.h.dl = 79;
    regs.h.bh = 0;
    int86 (0x10, &regs, &regs);
}
  
void clearprt ( ulx, uly, lrx, lry )
int ulx, uly, lrx, lry;
{
    regs.h.ah = 7;
    regs.h.al = 0;
    regs.h.ch = uly;
    regs.h.cl = ulx;
    regs.h.dh = lry;
    regs.h.dl = lrx;
    regs.h.bh = 0;
    int86 (0x10, &regs, &regs);
}
  
void error_and_exit ( string1, string2 )
char *string1, *string2;
{
    DisplayOff();
    system("CLS");
    printf("\n%s : %s\n", string1, string2 );
    printf("\t Execution terminated !\n");
    exit(1);
}
void blankstring (string1)
char *string1;
{
    strcpy(string1,"                                                                               ");
}
void mystring(n,string)
int n;
char *string;
{
    int i;
    char ch;

    fflush (stdin);
    for (i=0; (ch=getche()) != CR && ch !='\n' && ch != '\0'
         && i < n-1; i++) *string++ = ch;
    *string = '\0';
}
 
void myfloat (deflt, answ)
float deflt;
float *answ;
{
    char string[10];

    mystring(10,string);
    if (strlen(string) > 0) sscanf(string,"%f",answ);
    else *answ = deflt;
}

