/*****************************************************************************/
/**                                                                         **/
/**    Module: OPENCD - Open Compact Disc - Read Only Memory.               **/
/**                                                                         **/
/*****************************************************************************/
  
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <conio.h>
#include <time.h>
#include "menu.h"
#include "sonic.h"
  
#define LINESIZE  81
#define MAXFILES  32

extern char *menu1[];       /*  Defined in module Menu  */
extern char *mnu2[];
extern char *mnu3[];
extern int DisplayDevice;   /*  Defined in module Dispdriv  */
extern int dispnl;
extern int dispns;
  
FILE  *id1;                 /*  File identity for High Level I/O  */
  
static char  drpath[50];    /*  Drive letter for CD-ROM  */
char         filename[100]; /*  String for file name  */
char         year[6][5];    /*  Strings for determined years  */
char         mmon[14][51];  /*  Strings for menu with months  */
char         mday[16][25];  /*  Strings for menu with days  */
  
char mon[12][4] = {"JAN", "FEB", "MAR", "APR", "MAY", "JUN",
"JUL", "AUG", "SEP", "OCT", "NOV", "DEC"};
  
int  mdir;               /*  Number of main directories  */
int  sdir[6];            /*  Numbers of sub directories for each main  */
int  REFRESH_FREE;
BOOL CDROM = FALSE;
BOOL ORF1 = FALSE;
BOOL ORF2 = FALSE;
BOOL NEIC = FALSE;
  
int mdays [12] = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
  
void title ()
{
    char ch, text[30];
    int  i, color, line, sample, lsize, ssize;
  
    static char *mesg[20] = {
        "                       WELCOME TO                           ",
        "                                                            ",
        "           SONIC I - VERSION 1.97    ( AUGUST 1991 )        ",
        "                                                            ",
        "   THIS PROGRAM DISPLAYS SEISMIC DATA STORED  ON CD-ROM.    ",
        "   IT IS WRITTEN FOR IBM AND COMPATIBLE PERSONAL COMPUTERS  ",
        "   WITH THE ENHANCED GRAPHICS ADAPTER, THE COLOR GRAPHICS   ",
        "   ADAPTER  OR  THE PROFESSIONAL GRAPHICS ADAPTER.          ",
        "                                                            ",
        "                                                            ",
        "   THIS PROGRAM IS WRITTEN FOR USERS OF THE EVENT CD-ROM    ",
        "                        CREATED BY                          ",
        "                   THE ORFEUS DATA CENTER                   ",
        "                            AND                             ",
        "         THE NATIONAL EARTHQUAKE INFORMATION CENTER         ",
        "                                                            ",
        "  YOUR SYSTEM MUST BE EQUIPPED WITH A CGA, EGA, VGA OR PGA. ",
        "      READ THE INFO.DOC FILE FOR THE LATEST REVISIONS.      ",
    ""};
  
    /*  Plot the first screen (graphics mode)  */
    REFRESH_FREE = TRUE;
    InitDisplay();
  
    if ( DisplayDevice == 0 ) ClearDisplay(0);
    else {
        clearscr();
        ClearDisplay(15);
    }
  
    /*  Set Font Type equal to 5  */
    Font (5);
  
    for ( i=0; i < 5; i++ ) {
        if ( DisplayDevice == 0 ) color = 1;
        else {
            if ( i == 0 || i == 3 ) color = 9;
            if ( i == 1 || i == 4 ) color = 11;
            if ( i == 2 ) color = 15;
        }
  
        line   = dispnl / 12 + i * dispnl / 6;
        sample = dispns/10;
        lsize  = dispnl/6+1;
        ssize  = dispns/11+5;
  
        DrawBox (line, sample, lsize, ssize, color);
  
    }
  
    if ( DisplayDevice == 0 ) color = 0;
    else color = 16;
  
    strcpy (text, "S");
    for ( i=0; i < 3; i++ ) {
        sample = dispns/10+dispns/128+i;
        DrawText (text, (dispnl/4-dispnl/70), sample, (dispnl/7), 0, color);
    }
    strcpy (text, "O");
    for ( i=0; i < 3; i++ ) {
        sample = dispns/10+dispns/128+i;
        DrawText (text, (dispnl*5/12-dispnl/70), sample, (dispnl/7), 0, color);
    }
    strcpy (text, "N");
    for ( i=0; i < 3; i++ ) {
        sample = dispns/10+dispns/128+i;
        DrawText (text, (dispnl*7/12-dispnl/70), sample, (dispnl/7), 0, color);
    }
    strcpy (text, "I");
    for ( i=0; i < 3; i++ ) {
        sample = dispns/10+dispns/32+i;
        DrawText (text, (dispnl*3/4-dispnl/70), sample, (dispnl/7), 0, color);
    }
    strcpy (text, "C");
    for ( i=0; i < 3; i++ ) {
        sample = dispns/10+dispns/128+i;
        DrawText (text, (dispnl*11/12-dispnl/70), sample, (dispnl/7), 0, color);
    }
    if ( DisplayDevice == 0 ) color = 1;
  
    strcpy (text, "eismic Software");
    DrawText (text, (dispnl/4-dispnl/70),   (dispns/5), (dispnl/10), 0, color);
    strcpy (text, "RFEUS");
    DrawText(text, (dispnl*5/12-dispnl/70), (dispns/5), (dispnl/10), 0, color);
    strcpy (text, "EIC");
    DrawText(text, (dispnl*7/12-dispnl/70), (dispns/5), (dispnl/10), 0, color);
    strcpy (text, "nternational");
    DrawText (text, (dispnl*3/4-dispnl/70), (dispns/5), (dispnl/10), 0, color);
    strcpy (text, "ooperation");
    DrawText(text,(dispnl*11/12-dispnl/70), (dispns/5), (dispnl/10), 0, color);
    strcpy (text, "by");
    DrawText (text, (dispnl/4+dispnl/25),   (dispns/2), (dispnl/25), 0, color);
    strcpy (text, "and");
    DrawText(text, (dispnl*5/12+dispnl/25), (dispns/2), (dispnl/25), 0, color);
    strcpy (text, "through");
    DrawText(text, (dispnl*7/12+dispnl/25), (dispns/3), (dispnl/25), 0, color);
  
    /*  Set Font Type equal to zero again  */
    Font (0);
  
    /*  Pause before display is turned off  */
    pause(5);
    DisplayOff();
  
    /*  Print the second screen (text mode)  */
    clearscr ();
    set_colour ( 1, 0, 0, 79, 24 );
    set_colour ( 2, 5, 2, 74, 21 );
    set_colour ( 2, 10, 7, 69, 7);
    set_colour ( 3, 10, 19, 68, 20);
    textdisp (mesg, 9, 3, strlen(mesg[0])+8, 20);
  
    /*  Choose your cd-rom drive letter  */
    set_colour ( 2, 5, 23, 74, 23 );
    
    blankstring (menu1[0]);
    strcpy (menu1[0], " ENTER CD-ROM DRIVE [L]: ");
    textdisp (menu1, 5, 23, strlen(menu1[0])+4, 23);
    set_curs (23, 30);
                
    mystring(50,drpath);
    i=strlen(drpath);
    if(i==0) {
        strcpy(drpath,"L:");
        CDROM = TRUE;
    }
    else if (i==1) {
        strcat(drpath,":");
        if ( toupper( drpath[0] ) != 'C' ) CDROM = TRUE;
    }
}
  
int contents ()
{
    char months[12][4], path[50], tempmonth[5], ch;
    int  i, j, k, fmon, valmonth;
    struct find_t cdrom;
    char *prog_name = "CONTENTS";
  
    /*  Determine volume ID.  */
  
    strcpy(path,drpath);
    strcat(path,"\\*");
  
    do {
        if ( _dos_findfirst ( path, _A_SUBDIR, &cdrom ) != 0 ) {
            set_colour ( 2, 5, 23, 74, 23 );
            set_colour ( 3, 5, 23, 35, 23);
            
            blankstring (menu1[0]);
            strcpy (menu1[0], "  DRIVE LETTER IS NOT CORRECT. ENTER NEW LETTER or Q to QUIT: ");
            textdisp (menu1, 5, 23, 79, 23);
            set_curs (23, 71);
                        
            mystring(50,drpath);
            i=strlen(drpath);
            if(i==0) strcpy(drpath,"L:");
            else if (i==1) strcat(drpath,":");
            if(drpath[0]=='q' || drpath[0]=='Q') return(ESC);
            strcpy(path,drpath);
            strcat(path,"\\*");
        }
    } while ( _dos_findfirst ( path, _A_SUBDIR, &cdrom ) != 0 ) ;
  
    j = 0;
    /*  Determine the main directories ( years ).  */
    if ( _dos_findfirst ( path, _A_SUBDIR, &cdrom ) != 0 )
        error_and_exit ( prog_name,"Error finding year directories. Please check for the correct CD-ROM.");
  
    do {
        if (strlen (cdrom.name) == 4) {
            strcpy (tempmonth, cdrom.name);
            valmonth = atoi(tempmonth);
            if (valmonth == 0) continue;
            strcpy (year[j++], cdrom.name) ;
        }
    }  while ( _dos_findnext ( &cdrom ) == 0 ) ;   

    mdir = j; /*  mdir is the number of main directories found  */
    if ( mdir == 0) error_and_exit(prog_name, "No year directories found. Please check for the correct CD-ROM.");
  
    for (i=0; i < 14; i++) strset (mmon[i], ' ');
  
    /* Loop to find the subdirectories  */
  
    for (i=0; i < mdir; i++)  {
        strcat (mmon[0], year[i]);
        strcat (mmon[0], "    ");
        strcpy (mmon[1], "        ");
        k = 0;
        fmon = 11;
  
        strcpy(path,drpath);
        strcat(path,"\\");
        strcat ( path, year[i] );
        strcat ( path, "\\*" );
    
        if ( _dos_findfirst ( path, _A_SUBDIR, &cdrom ) != 0 )
            error_and_exit (prog_name, "Error in reading the months. " );
        do {   
            if (strlen(cdrom.name) != 3) continue;
            for ( j=0; j<12; j++ ) {
/*                if ( strncmp ( cdrom.name, "VLP", 3 ) == 0 ) break;*/
                if ( strncmp ( cdrom.name, mon[j], 3 ) == 0 ) {
                    if ( j < fmon )  fmon = j;
                    k++;
                    strcpy (months[j], cdrom.name);
                    break;
                }
            }
        } while ( _dos_findnext (  &cdrom ) == 0 ); 
 
        if ( k == 0) error_and_exit(prog_name, "No month directories found. Please check for the correct CD-ROM.");
  
        sdir[i] = k;
  
        /* determine disc type (doesn't work if data are on hard disc) */
  
        if ( CDROM ) {
            if ( mdir == 1 && ( strcmp (year[0],"1988") == 0 ) && sdir[0] == 4 )
                ORF2 = TRUE;          /* ORFEUS 881 disc */
            else if ( mdir == 6  )   ORF1 = TRUE;          /* ORFEUS NARS */
            else                     NEIC = TRUE;
        }
  
        if ( fmon > 0 ) {
            for (j=0; j < sdir[i]; j++)
                strcpy (months[j], months[j + fmon]);
        }
        if ( sdir[i] < 12 ) {
            for (j=sdir[i]; j < 12; j++)
                strcpy (months[j], "   ");
        }
  
        for (j=2; j < 14; j++) {
            strcat (mmon[j], months[j-2]);
            strcat (mmon[j], "     ");
        }
    }  /*  End of loop over the main directories  */
    return(1);
}
  
int getfile ( count )
INT count;
{
    BYTE          *menuA[14], *menuB[16], path[50], date[15];
    static BYTE   styr[5], stmon[4], name[MAXFILES][12];
    INT           row, col, i, k, lry[6], ipos[6], temp;
    INT           y, dofy, dy, mnth, daymo, pos, inpt=0;
    static INT    nfiles;
    struct find_t cdrom;
    BYTE          *prog_name = "GETFILE";
  
    /*
    *  In the software for sonic1 there are two possible values for count (cgf):
    *  cgf = 0: Selection of the year and month of interest.
    *  cgf = 1: Year and month are already known - selection of the date.
    *           Year, month and dates are stored in the static parameters
    *           styr, stmon and name. The number of the dates is stored in
    *           static int nfiles.
    */
  
    /*  Loop over the selection of the year and month  */
    do {
  
        clearscr ();
  
        /*  Colors are set for fore and back ground  */
        screen_setup();

        /*  MenuA is printed  */
        for( i=0; i<14; i++) {
              menuA[i] = &mmon[i][0];
        }
        textdisp (menuA, 5, 5, strlen(mmon[0])+4, 18);
  
        /*  Selection of the year and month of interest  */
        if ( count == 0 )  {

            blankstring (menu1[0]);
            strcpy (menu1[0], " SELECT YEAR/MONTH");
            textdisp (menu1, 0, 2, 79, 2);
            textdisp (mnu2, 0, 23, 79, 23);
  
            /*  Cursor selection from menu gives year and month  */
            row = 7;
            col = 0;
            for ( i=0; i<mdir; i++ ) {
                lry[i] = sdir[i]+7;
                ipos[i] = (i+1)*8 - 5;
            }
            if (mdir < 6) {
                for ( i=mdir; i<6; i++ ) {
                    lry[i] = lry[i-1];
                    ipos[i] = ipos[i-1];
                }
            }
  
            inpt = menucurs6 (&row, &col, ipos[0],6,ipos[0]+6,lry[0],
                                          ipos[1],6,ipos[1]+6,lry[1],
                                          ipos[2],6,ipos[2]+6,lry[2],
                                          ipos[3],6,ipos[3]+6,lry[3],
                                          ipos[4],6,ipos[4]+6,lry[4],
                                          ipos[5],6,ipos[5]+6,lry[5]);
  
            if ( inpt == ESC ) return(ESC);
  
            /*  Selected year is stored in static styr  */
            strcpy (styr, year[col]);
            row -= 5;
  
            /*  Selected month is stored in static stmon  */
            /*  Find offset in row */
            i = col*8;
            strncpy(stmon,mmon[row]+i,3);
  
            /*  Make pathname to eventfiles  */
            strcpy ( path, drpath);
            strcat(path,"\\");
            strcat ( path, styr );
            strcat (path, "\\");
            strcat (path, stmon);
            strcat ( path, "\\*.EVT");
  
            /*  Clear contents of strings name   */
            for ( i=0; i < MAXFILES; i++ ) strcpy ( name[i], " " );
  
            /*  Clear contents of strings mday  */
            for ( i=0; i < 16; i ++ ) strset (mday[i], ' ');
            k = 0;
            nfiles = 0;
  
            /*  First filename ...  */
            if ( _dos_findfirst ( path, _A_RDONLY, &cdrom ) != 0 )
                error_and_exit (prog_name, "Error in reading eventfiles. ");
  
            /*  Do loop over the next eventfiles. Store names in static array name  */
            do {
                if ( strncmp (cdrom.name, ".", 1 ) != 0 ) {
                    strncpy (name[nfiles++], cdrom.name, 11);
  
                    /*  Change filename to date  */
                    sscanf (cdrom.name, "%2d%3d", &y, &dofy);
                    y += 1900;
                    daymo = daymon ( y, dofy, &mnth, &dy);
                    if ( daymo != 1 )
                        error_and_exit (prog_name,"Error from function daymon.");
                    sprintf (date, "%2d %s", dy, mon[mnth]);
  
                    if ( k < 16 ) {
                        strcpy (mday[k], date);
                        strcat (mday[k], "    ");
                    }
                    else {
                        strcat (mday[k-16], date);
                        strcat (mday[k-16], "    ");
                    }
                    k++;
                } /* end of if statement */
            }  while ( _dos_findnext ( &cdrom ) == 0 );
  
            /*  Prepare strings mday[] for printing  */
            temp = nfiles % 16;
            if ( temp != 0 ) {
                for ( i=temp; i < 16; i++ )
                    strcat (mday[i], "          ");
            }
  
        }  /*  End if ( count == 0 )  */
  
  
        /*  Menu1 is displayed  */
        blankstring (menu1[0]);
        strcpy (menu1[0], " EVENT FILES FOR DATES IN ");
        strcat (menu1[0], stmon);
        strcat (menu1[0], " ");
        strcat (menu1[0], styr);
        textdisp (menu1, 0, 1, 79, 1);
        blankstring (menu1[0]);
        strcpy (menu1[0], " SELECT DAY");
        textdisp (menu1, 0, 2, 79, 2);
  
        /*  Menu B is displayed  */
        for (i=0; i < 16; i++) menuB[i] = &mday[i][0];
        textdisp (menuB, 55, 5, strlen(mday[0])+54, 20);
  
        /*  Mnu3 is displayed  */
        textdisp (mnu3, 0, 23, strlen(mnu3[0])-1, 23);
  
        /*  Cursor selection from menu gives name event file  */
        row = 5;
        col = 0;
        if (nfiles <= 16 ) {
            lry[0] = nfiles+5;
            inpt = menucurs6 (&row, &col, 53,4,62,lry[0], 53,4,62,lry[0],
                                          53,4,62,lry[0], 53,4,62,lry[0],
                                          53,4,62,lry[0], 53,4,62,lry[0]);
        }
        else {
            lry[0] = 21;
            lry[1] = nfiles+5-16;
            inpt = menucurs6 (&row, &col, 53,4,62,lry[0], 63,4,73,lry[1],
                                          63,4,73,lry[1], 63,4,73,lry[1],
                                          63,4,73,lry[1], 63,4,73,lry[1]);
        }
        if ( inpt == ESC ) count = 0;
  
    } while ( inpt == ESC );/*  End of loop over selection of year and month  */
  
    if (col == 0) pos = row-5;
    else pos = row-5+16;
  
    /*  File path is composed  */
    /*
    strcpy (filename, " :\\");
    filename[0] = drlet;
    */
    strcpy ( filename, drpath);
    strcat ( filename,"\\");
    strcat ( filename, styr);
    strcat ( filename, "\\");
    strcat ( filename, stmon);
    strcat ( filename, "\\");
    strcat ( filename, name[pos]);

    return(1);
}
  
void openfile ( )
{      
    char * prog_name = "openfile";

    /*  Open file on CD-ROM as a binary file (read only)  */
  

    if ( ( id1 = fopen (filename, "rb")) == NULL ) {
        sprintf (menu1[0],"Couldn't open file %s.", filename);
        error_and_exit ( prog_name, menu1[0]);
    }
}
  
int daymon ( yr, dofy, month, day )
int yr, dofy;
int *month, *day;
{
    int iday, maxdays, daymo;
  
    iday = dofy;
    if ( lpyr ( yr) == 0 ) {
        maxdays = 365;
        mdays[1] = 28;
    }
    else {
        maxdays  = 366;
        mdays[1] = 29;
    }
  
    if ( iday < 1 || iday > maxdays )  {
        *month = 0;
        *day   = 0;
        daymo  = 0;
        return daymo;
    }
  
    for (*month=0; *month < 12; (*month)++) {
        *day = iday;
        iday = iday - mdays[*month];
        if ( iday <= 0 ) {
            daymo = 1;
            return daymo;
        }
    }
    *month = 0;
    *day   = 0;
    daymo  = 0;
    return daymo;
}
  
int lpyr ( yr )
int yr;
{
    int lp;
  
    /*  lp = 1: leap year, lp = 0: no leap year. */
  
    if ( (yr % 400) == 0 )      lp = 1;
    else if ( (yr % 100) == 0 ) lp = 0;
    else if ( (yr % 4) == 0 )   lp = 1;
    else lp = 0;
    return lp;
}
  
void pause (mz)
int mz;
{
    time_t time1, time2;
    
    time(&time1);
    do {
        time(&time2);
        if (time2-time1 > mz) break;
    } while (1);
}
