/***************************************************************************/
/**                                                                       **/
/**             Module: RDDATA - Read Data Block.                         **/
/**                                                                       **/
/***************************************************************************/
  
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "menu.h"
#include "struct.h"
#include "sonic.h"
  
#define BLKSIZE   1000
#define BUFSIZE   2000
#define PLOTSIZE  1000
  
extern  INT     PLOTBUF_FREE;            /*  Defined in module sonic1  */
extern  INT     DATA_FLAG;
extern  FILE    *id1;                    /*  Defined in module opencd  */
extern  BOOL    ORF1, ORF2;
extern  INT     cdver;                   /*  Defined in module rdlog  */
extern  INT     nst;
extern  BYTE    *menu1[];                /*  Defined in module menu  */
extern  BYTE    *mnu3[];
extern  INT     plchoice;
  
BYTE      mdt[13][60];                     /*  Strings for menu data types  */
INT       *datablk;
float     *plotbuffer;                     /*  Buffer for plot data  */
long unsigned int       *mant, *gain;
INT     comp;
INT     numblocks;
  
BOOL  MANT_FREE = TRUE;
BOOL  GAIN_FREE = TRUE;
BOOL  DATABLK_FREE = TRUE;
BOOL     SHORT_PERIOD = FALSE;
BOOL     LONG_PERIOD = FALSE;
BOOL     INTERM_PERIOD = FALSE;
  
FLOAT     pwr[16] = {1024, 512, 256, 128, 64, 32, 16, 8, 4, 2, 1,
.5, .25, .125, .0625, .03125};
FLOAT     rstn[4] = {1, 4, 16, 128};
FLOAT     grf[13] = {4096, 2048, 1024, 512, 256, 128, 64, 32, 16, 8, 4, 2, 1};
  
static  BYTE *mnu3b[] = {" CONTINUE          ",
" WRITE TO HARD DISK" };
  
int seldata( stnum, stname, nchan, chan_avail )
BYTE  *stname;
INT  stnum, *nchan, *chan_avail;
{
    BYTE      *menuD[13];
    INT       i, nsmp, row, col, inpt, uly, lry, numc, lry1, lry2, showdl;
    static INT numd;
    INT        recno, no;
    char      ofname[15], suffix[5];
  
    clearscr();
    screen_setup();
  
    /*  Menu1 is displayed  */
    blankstring (menu1[0]);
    if ( plchoice == 1 ) {
        strcpy (menu1[0], " STATION SELECTED: ");
        strcat (menu1[0], stname);
    }
    textdisp (menu1, 0, 1, 79, 1);   /* THIS will be a blank line for plchoice = 2 */

    blankstring (menu1[0]);
    strcpy (menu1[0], " SELECT DATA TYPE AND COMPONENT");
    textdisp (menu1, 0, 2, 79, 2);
  
    /*  Fill the first part of the menu - data type  */
    if ( !DATA_FLAG ) {
  
        /*  Clear the contents of strings mdt  */
        for ( i=0; i < 13; i++ )   strset (mdt[i], ' ');
        strcpy (mdt[0], "DATA TYPE:   ");
  
  
        if ( plchoice == 1 ) {
            strcpy (mdt[6], "PLOT COMPONENT(S):                     SHOW DATA LOG(S): ");
            numd = 0;
            numc = 0;
  
            /*  Check to determine which data types and components are available  */
            if ( st[stnum].len[0] != 0 ) {
                strcpy (mdt[2], "SHORT        ");
                numd++;
            }
            if ( st[stnum].len[1] != 0 ) {
                strcpy (mdt[3], "LONG         ");
                numd++;
            }
            if ( st[stnum].len[2] != 0 ) {
                strcpy (mdt[4], "INTERMEDIATE ");
                numd++;
            }
        }
        else {
            strcpy (mdt[6], "PLOT COMPONENT(S):  ");
            if ( ORF1 || ORF2  )        /* ORFEUS_NARS */
                strcpy (mdt[4], "INTERMEDIATE ");
            else {         /* NEIC */
                strcpy (mdt[2], "SHORT        ");
                strcpy (mdt[3], "LONG         ");
                strcpy (mdt[4], "INTERMEDIATE ");
            }
        }
    }  /*  End if ( DATA_FLAG )  */
  
    /*  MenuD is displayed  */
    for ( i=0; i < 13; i++ ) menuD[i] = &mdt[i][0];

    textdisp (menuD, 2, 5, (strlen(mdt[6])+1), 11);
  
    textdisp (mnu3, 0, 23, 79, 23);
  
    /**************************************************************************/
    /*  Cursor selection from menu gives datatype  */
    for(;;) {
        col = 0;
        if ( plchoice == 1 ) {
            if ( st[stnum].len[0] != 0)        row = 7;
            else  {
                if ( st[stnum].len[1] != 0)     row = 8;
                else                            row = 9;
            }
        }
        else row = 7;
  
        if ( ORF1 || ORF2 ) row = 9;        /* ORFEUS_NARS has only intermediate components          */
        uly = row - 1;
        if ( plchoice == 1 )    lry = row + numd;
        else                    lry = 10;
  
        inpt = menucurs6 (&row, &col, 0,uly,15,lry,
                                      0,uly,15,lry,
                                      0,uly,15,lry,
                                      0,uly,15,lry,
                                      0,uly,15,lry,
                                      0,uly,15,lry);
  
        if ( inpt == ESC )   return ESC;
  
        SHORT_PERIOD  = FALSE;
        LONG_PERIOD   = FALSE;
        INTERM_PERIOD = FALSE;
        if ( row == 7 )         SHORT_PERIOD = TRUE;
        else if ( row == 8 )    LONG_PERIOD = TRUE;
        else                    INTERM_PERIOD = TRUE;
  
        if ( plchoice == 1 )  {
            numblocks = st[stnum].len[row-7] - 3;
        }
  
        /*  Fill the second part of the menu - data component  */
        /*  Give possibility to plot the data or show the datalogs (only for A. vs. time plot  ) */
        for(;;) {
            if ( plchoice == 1 ) {
  
                /*  Read first data block to determine number of channels  */
                movedblck ( stnum, 0 );
                rddatablock (&nsmp);
                if ( !DATABLK_FREE ) {
                    free ( datablk );  /*  allocated in rddatablock   */
                    DATABLK_FREE = TRUE;
                }
                numc = hdr.nchan;
                *chan_avail = numc;
                lry = 17;
                strcpy (mdt[8], "VERTICAL                               STATION LOG");
  
                if ( numc == 3 ) {
                    strcpy (mdt[9],  "NORTH / SOUTH                          DATA LOG 1"); 
                    strcpy (mdt[10], "EAST / WEST                            DATA LOG 2");
                    strcpy (mdt[11], "ALL                                    DATA LOG 3");
                    strcpy (mdt[12], "                                       ALL");
 
                }
                else {
                    strcpy (mdt[9],  "                                       DATA LOG 1");
                    strcpy (mdt[10], "                                       DATA LOG 2");
                    strcpy (mdt[11], "                                       DATA LOG 3");
                    strcpy (mdt[12], "                                       ALL");
 
                }
            }
            else {         /* plchoice = 2 */
                lry = 15;
                strcpy (mdt[8], "VERTICAL     ");
                strcpy (mdt[9], "NORTH / SOUTH");
                strcpy (mdt[10],"EAST / WEST  ");
            }
  
            textdisp (menuD, 2, 5, strlen(mdt[6])+1, lry);
            col = 0;
            row = 13;
            if ( plchoice == 1 ) {
                if ( numc == 1 ) lry1 = 14;
                else if ( numc == 3 ) lry1 = 17;
                lry2 = 18;
                inpt = menucurs6 (&row, &col, 0,12,16,lry1,
                                             38,12,54,lry2,
                                             38,12,54,lry2,
                                             38,12,54,lry2,
                                             38,12,54,lry2,
                                             38,12,54,lry2);
            }
            else {
                lry = 16;
                inpt = menucurs6 (&row, &col, 0,12,16,lry,
                                              0,12,16,lry,
                                              0,12,16,lry,
                                              0,12,16,lry,
                                              0,12,16,lry,
                                              0,12,16,lry);
            }
            if ( inpt == ESC ) {
                re_vid ( row, 0, row, 16, row);
                if ( plchoice == 1 ) {
                    clearprt (1, 13, strlen(mdt[6])+1, 17);
                    set_colour ( 2, 1, 13, strlen(mdt[6]) +1, 17 );
                }
                break;
            }
  
            comp = row - 13;
            if ( comp != 3 )    *nchan = 1;
            else                *nchan = 3;
  
            if( plchoice == 1 ) {
                /* Valid values for row are 13 through 17, making showdl equal to 1 through 5 */
                if ( col == 1 )  showdl = row - 12;
                else return 1;
  
                if ( showdl == 1 || showdl == 5) {
                    strcpy(ofname,st[stnum].codes);
                    strcat(ofname,"_ST.LOG");
                    recno = st[stnum].pos - 1;
                    show_data_log(recno,ofname);
                }
                if ( SHORT_PERIOD  ) {
                    no = st[stnum].pos;
                    strcpy(suffix,"_SP.");
                }
                else if ( LONG_PERIOD ) {
                    no = st[stnum].pos+st[stnum].len[0];
                    strcpy(suffix,"_LP.");
                }
                else {
                    no = st[stnum].pos+st[stnum].len[0] + st[stnum].len[1];
                    strcpy(suffix,"_IP.");
                }
                if ( showdl == 2 || showdl == 5) {
                    strcpy(ofname,st[stnum].codes);
                    strcat(ofname,suffix);
                    strcat(ofname,"1");
                    recno = no;
                    show_data_log(recno,ofname);
                }
                if ( showdl == 3 || showdl == 5) {
                    strcpy(ofname,st[stnum].codes);
                    strcat(ofname,suffix);
                    strcat(ofname,"2");
                    recno = no + 1;
                    show_data_log(recno,ofname);
                }
                if ( showdl == 4 || showdl == 5) {
                    strcpy(ofname,st[stnum].codes);
                    strcat(ofname,suffix);
                    strcat(ofname,"3");
                    recno = no + 2;
                    show_data_log(recno,ofname);
                }
                clearscr();
                screen_setup();

                blankstring (menu1[0]);
                strcpy (menu1[0], " STATION SELECTED: ");
                strcat (menu1[0], stname);
                textdisp (menu1, 0, 1, 79, 1); 

                blankstring (menu1[0]);
                strcpy (menu1[0], " SELECT DATA TYPE AND COMPONENT");
                textdisp( menu1, 0, 2, 79, 2);

                textdisp( mnu3, 0, 23, strlen(mnu3[0])-1, 23);
                continue; /* RESUMES at FOR loop for second part of menu */
            }
            else  if ( plchoice == 2 ) {
                blankstring(menu1[0]);
                textdisp (menu1, 0, 23, 79, 23);
                return 1;
            }
        }
    }
}
  
void show_data_log (recno, ofname)
INT recno;
BYTE *ofname;
{
    FILE        *idlog;
    INT         i,inpt, row, col;
    BYTE        *stlog[25];
    char        *buffer;
  
    buff_all(&buffer);
  
    cdread(recno,buffer);
    clearscr();
    set_colour ( 2, 0, 0, 79, 24 );
  
    for( i=0; i<25; i++) *(stlog+i)= buffer + 80*i;
  
    textdisp(stlog, 0, 0, 79, 24);
    textdisp( mnu3b, 56, 23, 56 + strlen(mnu3b[1]) -1, 24);
  
    row = 23;
    col = 0;
    inpt = menucurs6(&row, &col, 53, 22, 79, 25,
                                 53, 22, 79, 25,
                                 53, 22, 79, 25,
                                 53, 22, 79, 25,
                                 53, 22, 79, 25,
                                 53, 22, 79, 25);
    if ( row == 24 ) {
            idlog = fopen ( ofname, "w+");
            for ( i=0;i<2000;i++ ) fprintf(idlog,"%c",buffer[i]) ;
            fclose( idlog);
    }
  
    free(buffer);
}
  
void rdtimes ( stnum, totevt, evnum, evday, evtime, evtime2, begintime, endtime )
INT       stnum, totevt, evnum, evday;
FLOAT     evtime, evtime2, *begintime, *endtime;
{
    INT   nsmp, day=0, hour=0, minute=0, sec=0, mss=0, stday=0;
    FLOAT time, ms;
  
    /*  Initialization of parameters  */
    *begintime = 0;
    *endtime = 0;
  
    /*  Move file handle to position of first datablock  */
    movedblck ( stnum, 0 );
    rddatablock (&nsmp);
  
    if ( !DATABLK_FREE ) {
        free ( datablk );
        DATABLK_FREE = TRUE;
    }
  
    /*  Determine day of begintime data record  */
    stday = hdr.day;
  
    /*  Determine begintime of the plot  */
    /*  IF THE USER SELECTED THE FIRST EVENT OR ALL THE EVENTS */
    /*  SET begintime EQUAL TO THE TIME OF THE FIRST RECORD */
    if ( evnum == 1 || evnum == 999 ) {
        *begintime = (float) hdr.hour*3600+hdr.minute*60+hdr.sec+hdr.mss/1000;
/******        if ( stday != evday ) *begintime += 86400; ******/
    }
    /* IF THE USER SELECTED ANY OTHER EVENT */
    /* SET begintime EQUAL TO THE TIME OF THE EVENT */
    else {
        *begintime = evtime;
    }
  
    /*  Determine end time of the plot  */
    /* IF THERE IS ONLY ONE EVENT OR */
    /*        IF THE USER SELECTED THE LAST EVENT OR */
    /*        IF THE USER SELECTED ALL THE EVENTS, */
    /* SET endtime EQUAL TO THE TIME OF THE LAST DATA BLOCK */
    if ( (totevt == 1) || (evnum >= totevt) ) {
  
        /*  Move file handle to position of last datablock  */
        movedblck (stnum, numblocks-1 );
        rddatablock (&nsmp);
        if ( !DATABLK_FREE ) {
            free ( datablk );
            DATABLK_FREE = TRUE;
        }
  
        time = (float) (nsmp-1) / hdr.rate;
        minute = (int) time / 60;
        sec = (int) time % 60;
        ms  = fmod ((time*1000), 1000);
        mss = (int) ms;
  
        mss = (int) hdr.mss + mss;
        while ( mss > 999 ) {
            mss -= 1000;
            sec += 1;
        }
        sec += hdr.sec ;
        while ( sec > 59 ) {
            sec -= 60;
            minute += 1;
        }
        minute += hdr.minute ;
        while ( minute > 59 ) {
            minute -=  60;
            hour += 1;
        }
        hour += hdr.hour;
        while ( hour > 23 ) {
            hour -= 24;
            day += 1;
        }
        day = hdr.day + day;
  
        *endtime = (float)hour*3600 + (float)minute*60 + (float)sec + (float)mss/1000;
  
        if ( day != stday )      *endtime += 86400;
/*****  if ( stday != evday )    *endtime += 86400; ******/
    }
    /* OTHERWISE, IF THE USER SELECTED ANY OTHER EVENT */
    /* SET endtime EQUAL TO THE TIME OF THE NEXT EVENT,*/
    /* WHICH IS evtime2 */
    else {
        *endtime = evtime2;
   }
}
  
void settime ( evtime, distmax, t0, t1 )
FLOAT evtime, distmax, *t0, *t1;
{
    INT   nsmp, p, i, stnum;
    FLOAT tb,tbeg;
  
    if ( SHORT_PERIOD )        p = 0;
    else if ( LONG_PERIOD )    p = 1;
    else if ( INTERM_PERIOD )  p = 2;
    tbeg = 86400;
  
    for ( i=0 ; i<nst ; i++ ) {
        stnum = st[i].nums;
        if ( st[stnum].len[p] != 0 )  {
            movedblck(stnum, 0);
            rddatablock(&nsmp);
            if ( !DATABLK_FREE ) {
                free ( datablk );
                DATABLK_FREE = TRUE;
            }
            tb = (float)hdr.hour*3600 + hdr.minute*60 + hdr.sec +hdr.mss/1000;
            if ( tb < tbeg  ) tbeg = tb;
        }
    }
  
    if ( tbeg < evtime ) tbeg = evtime;
    *t0 = tbeg;
    if ( distmax <= 30 )        *t1 = *t0 + 2900;
    else if ( distmax <= 60 )   *t1 = *t0 + 3700;
    else if ( distmax <= 100 )  *t1 = *t0 + 4500;
    else if ( distmax <= 140 )  *t1 = *t0 + 5900;
    else                        *t1 = *t0 + 6900;
  
}
  
void settime2 (  t0, t1, evtime )
FLOAT *t0, *t1, evtime;
{
    INT   numbl, nsmp, p, i, stnum;
    FLOAT tb,te,tbeg;
  
    if ( SHORT_PERIOD )        p = 0;
    else if ( LONG_PERIOD )    p = 1;
    else if ( INTERM_PERIOD )  p = 2;
  
    *t0 = evtime;
    tbeg = 86400;
    *t1 = 0;
  
    for ( i=0 ; i<nst ; i++ ) {
        stnum = st[i].nums;
        if ( ( numbl = st[stnum].len[p] ) != 0 )  {
            movedblck(stnum, 0);
            rddatablock(&nsmp);
            if ( !DATABLK_FREE ) {
                free ( datablk );
                DATABLK_FREE = TRUE;
            }
            tb = (float)hdr.hour*3600 + hdr.minute*60 + hdr.sec +hdr.mss/1000;
            if ( tb < tbeg ) tbeg = tb;
  
            if ( ! ( comp >= hdr.nchan )  ) {
                movedblck(stnum, (numbl - 4));
                rddatablock(&nsmp);
                if ( !DATABLK_FREE ) {
                    free ( datablk );
                    DATABLK_FREE = TRUE;
                }
                te = (float)hdr.hour*3600 + hdr.minute*60 + hdr.sec +hdr.mss/1000;
                te += (float)(nsmp -1)/hdr.rate;
                if( te < (*t0) ) te += 86400;  /* new day ! */
                if ( te > (*t1)) *t1 = te;
            }
        }
    }
  
    *t0=tbeg;
    if ( (*t1) - (*t0)  > 84600 ) (*t0) += 84600;
    *t1 += 0.1 * ( (*t1) - (*t0) );
}
  
void movedblck ( stnum, shift )
INT  stnum, shift;
{
    INT recno;
  
    /*  Move file handle to position of secified datablock  */
    if ( SHORT_PERIOD ) recno = st[stnum].pos+3+shift;
    else if ( LONG_PERIOD ) recno = st[stnum].pos+st[stnum].len[0]+3+shift;
    else recno = st[stnum].pos+st[stnum].len[0]+ st[stnum].len[1]+3+shift;
    cdpos(recno);
}
  
void rddatablock ( nsmp )
INT *nsmp;
{
    BYTE *prog_name = "RDDATABLOCK";
  
    if ( DATABLK_FREE ) {
        if (( datablk = (int *) malloc (BLKSIZE*(sizeof(int)) )) == NULL )
            error_and_exit ( prog_name, "Insufficient memory available ");
        DATABLK_FREE = FALSE;
    }
  
    if( cdver == 1) cdver = 3;
    cdintread(-1);
    if( cdver == 3) cdver = 1;
  
    /*  Fill the data header  */
    head();
    if ( hdr.nchan == 0 ) error_and_exit ( prog_name,"Number of channels is 0");
    *nsmp = hdr.nsamp / hdr.nchan;
}
  
void swbyte ( temp )          /*  Data block of type int is read into  */
/*  array temp of type char !  */
char *temp;
{
    INT  i, tt;
    BYTE *prog_name = "SWBYTE";
  
    switch ( cdver ) {
  
        case 1:                          /*  CD-VERSION 1 for ascii blocks  */
            for (i=0; i < 2000; i=i+4) {
                tt = *(temp+i);
                *(temp+i) = *(temp+i+3);
                *(temp+i+3) = tt;
                tt = *(temp+i+1);
                *(temp+i+1) = *(temp+i+2);
                *(temp+i+2) = tt;
            }
            break;
  
        case 2:                          /*  CD-VERSION 2 for data blocks  */
            for (i=0; i < 2000; i=i+2) {
                tt = *(temp+i);
                *(temp+i) = *(temp+i+1);
                *(temp+i+1) = tt;
            }
            break;
  
        case 3:                          /*  CD-VERSION 1 for data blocks  */
            for (i=0; i < 2000; i=i+4) {
                tt = *(temp+i);
                *(temp+i) = *(temp+i+2);
                *(temp+i+2) = tt;
                tt = *(temp+i+1);
                *(temp+i+1) = *(temp+i+3);
                *(temp+i+3) = tt;
            }
            break;
  
        default:
            error_and_exit (prog_name," cdver not equal to 1 or 2 !");
  
    }
}
  
void head ()  /*  Head decodes header information and sets appropiate values in  */
/*  structure hcb.  */
{
    INT s, bits, ns, n;
    long unsigned int b[40];
  
    s  = 0;
    bits = 4;
    ns = 0;
    n  = 40;
  
    gbytes ( datablk, b, s, bits, ns, n);
  
    hdr.id    = (b[0]*10 + b[1])*10 + b[2];
    hdr.year  = b[3]*10 + b[4] + 1900;
    hdr.day   = (b[5]*10 + b[6])*10 + b[7];
    hdr.hour  = b[8]*10+b[9];
    hdr.minute= b[10]*10+b[11];
    hdr.sec   = b[12]*10+b[13];
    hdr.mss   = (float)((b[14]*10+b[15])*10+b[16]);
    hdr.form  = b[17];
    hdr.nchan = b[20]*10+b[21];
    hdr.rate  = (float)( (pow (10, (5-b[22]))) * (b[23]*10+b[24]) );
    hdr.nsamp = (b[25]*10+b[26])*10+b[27];
  
}
  
void decode ( maxn )
FLOAT maxn[];
{
    INT   i, j;
    BYTE  *prog_name = "DECODE";
  
  
    if ( MANT_FREE ) {
        if ( ( mant = (long unsigned int *) malloc ( PLOTSIZE * sizeof(long unsigned int) ) ) == NULL )
            error_and_exit (prog_name,"Insufficient memory available. ");
        MANT_FREE = FALSE;
    }
    else error_and_exit ( prog_name, "Mant not yet freed ");
  
    if ( GAIN_FREE ) {
        if ( ( gain = (long unsigned int *) malloc ( PLOTSIZE * sizeof(long unsigned int) ) ) == NULL )
            error_and_exit (prog_name,"Insufficient memory available. ");
        GAIN_FREE = FALSE;
    }
    else error_and_exit ( prog_name, "Gain not yet freed ");
  
  
    if ( PLOTBUF_FREE ) {
        if ( ( plotbuffer = (float *)malloc( PLOTSIZE * sizeof (float) ) ) == NULL )
            error_and_exit (prog_name,"Insufficient memory available. ");
        PLOTBUF_FREE = FALSE;
    }
    else printf("plotbuf not free\n");
  
    switch ( hdr.form ) {
  
        case 1:  /*  SRO format  */
        case 5:  /*  GEOSCOPE format  */
        case 6:  /*  ECHERY format  */
            gbytes (datablk, mant, 164, 12, 4, hdr.nsamp);
            gbytes (datablk, gain, 160, 4, 12, hdr.nsamp);
            break;
  
        case 2:  /*  DWWSSN format  */
            gbytes (datablk, mant, 160, 16, 0, hdr.nsamp);
            break;
  
        case 3:  /*  RSTN format  */
            gbytes (datablk, mant, 162, 14, 2, hdr.nsamp);
            gbytes (datablk, gain, 160, 2, 14, hdr.nsamp);
            break;
  
        case 4:  /*  GRF format  */
            gbytes (datablk, mant, 160, 12, 4, hdr.nsamp);
            gbytes (datablk, gain, 172, 4, 12, hdr.nsamp);
            break;

        case 7:  /* GEOSCOPE 3 byte */
            gbytes (datablk, mant, 160, 8,16, hdr.nsamp); 
            gbytes (datablk, gain, 168, 8,16, hdr.nsamp);
            geobyte (mant,gain,hdr.nsamp);
            gbytes (datablk, gain, 176, 8, 16, hdr.nsamp);
            break;
  
        default:
            clearscr();
            error_and_exit ( prog_name,"Format error.");
    }
  
    if ( hdr.nchan == 1 )  {
        for ( i=0; i < hdr.nsamp; i++ )
            *(plotbuffer+i) = dtfrmt ( *(mant+i), *(gain+i) ) / maxn[0];
    }
    else {
        j = 0;
        for ( i=0; i < hdr.nsamp; i += hdr.nchan )
            *(plotbuffer+(j++)) = dtfrmt ( *(mant+i), *(gain+i) ) / maxn[0];
  
        j = 330;
        for ( i=1; i < hdr.nsamp; i += hdr.nchan )
            *(plotbuffer+(j++)) = dtfrmt ( *(mant+i), *(gain+i) ) / maxn[1];
  
        j = 660;
        for ( i=2; i < hdr.nsamp; i += hdr.nchan )
            *(plotbuffer+(j++))= dtfrmt ( *(mant+i), *(gain+i) ) / maxn[2];
    }
  
    if ( !MANT_FREE ) {
        free(mant);
        MANT_FREE = TRUE;
    }
    if ( !GAIN_FREE ) {
        free(gain);
        GAIN_FREE = TRUE;
    }
  
    if ( !DATABLK_FREE ) {
        free ( datablk );
        DATABLK_FREE =TRUE;
    }
}
  
float dtfrmt (mant1, gain1)
long unsigned int mant1, gain1;
{
    float sample;
  
    switch ( hdr.form ) {
        case 1:       /*  SRO format  */
            sample = (float) mant1;
            if ( sample >= 2048 ) sample -= 4096;
            sample = sample*pwr[gain1];
            break;
        case 2:       /*  DWWSSN format  */
            sample = (float) mant1;
            if ( sample >= 32768. ) sample -= 65536.;
            break;
        case 3:       /*  RSTN format  */
            sample = (float) mant1;
            sample = (sample-8191)*rstn[gain1];
            break;
        case 4:       /*  GRF format  */
            sample = (float) (mant1);
            if ( sample >= 2048 ) sample -= 4096;
            sample = sample*grf[gain1];
            break;
        case 5:       /*  GEOSCOPE format  */
        case 6:       /*  ECHERY format */
            sample = (float) (mant1);
            sample = (sample-2048) * pow (2, -(double)gain1);
            break;
        case 7:       /*  GEOSCOPE 3 BYTE format */ 
            mant1 = (mant1 << 8);
            mant1 = mant1 + gain1;
            sample = (float) mant1;
            if (sample >= 8388608L) sample -= 16777216L;
            break;
        default:
            sample = 0.0;
            break;
    }
    return (sample);
}
void geobyte (ia, ib, n)
long unsigned int *ia, *ib;
INT n;
{
    INT i;
    long unsigned int ic;

    for (i=0; i<n; i++) {
        ic = *ia;
        *ia++ = (ic << 8) + *ib++;
    }
}
  
/* Gbytes_ treats ia as a bit string.
n bytes each ibits long are extracted from ia
and placed in the low order end of successive
words of ib (zero padded to the left).
is bits are skipped before the first byte.
ns bits are skipped between successive bytes.
*/
  
void gbytes (ia, ib, is, ibits, ns, n)
INT *ia, is, ibits, ns, n;
long unsigned int *ib;
{
    INT i, bit, word, bits;
  
    bits = is;
    for (i=0; i < n; i++) {
        bit = bits%16;
        word = (bits - bit)/16;
        bit = 15 - bit;
        *ib++ = getbits((unsigned)(ia[word]),(unsigned)(bit),(unsigned)(ibits));
        bits = bits + ibits + ns;
    }
}
  
/* Getbits gets n bits from position p.
*/
  
long unsigned int getbits (x, p, n)    /* get n bits from position p */
unsigned x, p, n;
{
    return((x >> (p+1-n)) & ~(~0 << n));
}
  
void buff_all(buffer)
char  **buffer;
{
    if ((*buffer = (char *) malloc(BUFSIZE*sizeof(char))) == NULL)
        error_and_exit ("BUFF_ALL"," Insufficient memory available.");
}
  
void cdread (recno, buffer)
INT    recno;
char  *buffer;
{
    BYTE *prog_name = "CDREAD";
  
    if (recno >= 0) cdpos(recno);
    if (fread( buffer,sizeof( *buffer),BUFSIZE,id1) == NULL)
        error_and_exit (prog_name,"Could not read data log.");
    if (cdver == 1) swbyte( buffer);
}
  
void cdintread (recno)
INT recno;
{
    BYTE *prog_name = "CDINTREAD";
  
    if (recno >= 0) cdpos(recno);
    if (fread( datablk,sizeof( *datablk),BLKSIZE,id1) != BLKSIZE)
        error_and_exit (prog_name,"Could not read data record.");
    swbyte( (char *)datablk);
}
  
void cdpos (recno)
INT recno;
{
    LONG  offset;
    INT   position;
    BYTE  *prog_name = "CDPOS";
  
    offset = (long) (recno)*2000;
    position = fseek(id1,offset,SEEK_SET);
    if (position) error_and_exit (prog_name," Seeking error.");
}
