/***    Program: SONIC2 - Interactive CD-ROM Selection Program.
-------------------------------------------------------
  
This module contains the main function of an interactive CD-ROM
selection program for the IBM and compatible personal computers.
  
version 1.92  -  september 1990
  
***/
  
#include <stdio.h>
#include <string.h>
#include "menu.h"
#include "sonic.h"
  
#define FOREVER   for(;;)
  
extern FILE  *id1;                     /*  Defined in module opencd2  */
extern char  year[][5];
extern char  mon1[][4];
extern char  mon2[][4];
extern char  mon3[][4];
extern char  mon4[][4];
extern char  mon5[][4];
extern char  mon6[][4];
extern int   nmain;
extern int   nsub[6];
  
extern FILE   *id3;                      /*  Defined in module rdlog2  */
extern char   evtline[][81];
extern int    totstat, nmatch;
extern char   *menu1[];                  /*  Defined in module menu  */
extern int    DisplayDevice;             /*  Defined in module dispdriv  */
  
main ()
{
    char cdinfo[10], cdyr[5], cdmon[4], fname[15], stinfo;
    int  i, j, k, l, m, ncol, nfiles, nevt, cco=0, cse=0;
  
    /*  Print the title pages  */
    title ();
  
    FOREVER {  /*  Determine the contents of the CD-ROM  */
        if (contents2 ( cco, cdinfo, &ncol, &stinfo) == ESC) break;
  
        /*  Select parameters for events only or events and stations of interest  */
        selparam ( cse, stinfo );
  
        /*  Open file on hard disk to write results to  */
        openhdfile ( cdinfo, fname );
  
        /*  Scanning of the CD-ROM  */
        clearscr ();
        screen_setup();
  
        blankstring (menu1[0]);
        strcpy (menu1[0], " SCANNING THE CD-ROM      OUTPUT FILE : ");
        strcat (menu1[0], fname );
        textdisp (menu1, 0, 1, 79, 1);
  
  
        blankstring (menu1[0]);
        strcpy (menu1[0], "    SCANNING THE LOGS ON THE CD-ROM    ");
        textdisp (menu1, 17, 23, strlen(menu1[0])+16, 23);
  
        /*  Loop over the main directories (years)  */
        for ( i=0; i < nmain; i++) {
  
            if ( ( strlen (cdinfo) ) == 4 )      /*  Only one year  */
                strcpy (cdyr, cdinfo);
            else if ( ( strlen (cdinfo) ) == 3 )  {   /*  Whole cd-rom  */
                strcpy ( cdyr, year[i] );
                ncol = i;
            }
  
            /*  Loop over the sub directories (months)  */
            for ( j=0; j < nsub[ncol]; j++ ) {
  
                if ( ( strlen (cdinfo) ) == 7 ) {     /*  Only one month  */
                    strncpy ( cdyr, cdinfo, 4 );
                    cdyr[4] = '\0';
                    strncpy ( cdmon, cdinfo+4, 3 );
                    cdmon[3] = '\0';
                }
                if ( strlen (cdinfo) == 3  || strlen ( cdinfo ) == 4  ) {  /*  Whole cd-rom  */
                    if ( ncol == 0 ) strcpy (cdmon, mon1[j]);
                    else if ( ncol == 1 ) strcpy (cdmon, mon2[j]);
                    else if ( ncol == 2 ) strcpy (cdmon, mon3[j]);
                    else if ( ncol == 3 ) strcpy (cdmon, mon4[j]);
                    else if ( ncol == 4 ) strcpy (cdmon, mon5[j]);
                    else if ( ncol == 5 ) strcpy (cdmon, mon6[j]);
                }
  
                getfilenames ( cdyr, cdmon, &nfiles );
  
                /*  Loop over the file names (dates)  */
                for ( k=0; k < nfiles; k++ ) {
  
                    /*  Open file on the CD-ROM  */
                    openfile2 (k);
  
                    /*  Read CD-file I/O block - First block of file  */
                    rdcdid2(k);
  
                    /*  Read EVENT-log from this file - Third block of file  */
                    rdevl2 (&nevt);
  
                    /*  Loop over the selected event logs only  */
                    for ( l=0; l < nevt; l++ ) {
  
                        /*  Write eventline to file on hard disk  */
                        fprintf (id3, "%s\n", evtline[l] );
  
                        if ( stinfo == 'y' ) {
  
                            /*  Change color for event info  */
                            set_colour ( 1, 0, 5, 79, 6 );
  
                            /*  Loop over the station logs  */
                            for ( m=0; m < totstat; m++ ) {
  
                                /*  Read STATION-log for this event  */
                                rdstl2 (l, m);
  
                            }  /*  End do-loop stations  */
  
                            /*  Change color for station info  */
                            set_colour ( 1, 0, 8, 79, 9 );
  
                        }  /*  End of if ( stinfo == 'y' )  */
  
                    }  /*  End do-loop events  */
  
                    /*  Close file on CD-ROM  */
                    fclose(id1);
  
                }  /*  End do-loop dates  */
  
                if ( (strlen (cdinfo)) == 7 ) break;
  
            }  /*  End do-loop months  */
  
            if ( (strlen (cdinfo)) == 7 || (strlen (cdinfo)) == 4 ) break;
  
        }  /*  End do-loop years  */
  
        /*  Close catalog-file on hard disk  */
        fclose(id3);
  
        /*  Continue  */
        cco = 1;
        cse = 1;
        nmatch = 0;
/* BACK TO FIRST MENU */
    }
    system("CLS");
    exit(1);
}
